; Assembled with Solar Assembler version 0.7.1
; Display a dialog box using binary resource templates

import_dll kernel32.dll

    import_func ExitProcess
    import_func GetModuleHandleA

import_dll user32.dll

    import_func DialogBoxIndirectParamA
    import_func EndDialog
    import_func LoadCursorA
    import_func SetCursor

WM_INITDIALOG   equ 110h
WM_SETCURSOR    equ 20h
WM_CLOSE        equ 10h
IDC_CROSS       equ 32515

section "code"  class_code
section "data"  class_data
section "idata" class_imports

.data

pTemplate:
INCBIN Rsrc.bin

hInstance   dd 0
CommandLine dd 0
hCursor     dd 0

.entry start

.code

start:

    invoke	GetModuleHandleA,0
    mov	[hInstance],eax
    invoke	DialogBoxIndirectParamA,[hInstance],pTemplate,0,DlgProc,0
    invoke	ExitProcess,eax

PROC DlgProc

    ARG hWnd,uMsg,wParam,lParam

    cmp     [uMsg],WM_CLOSE	
    jnz	initdlg
    invoke  EndDialog,[hWnd],0
    jmp     true
    
initdlg:
	
    cmp     [uMsg],WM_INITDIALOG
    jnz     setcursor
    invoke  LoadCursorA,0,IDC_CROSS
    mov     [hCursor],eax
    jmp true

setcursor:

    cmp    [uMsg],WM_SETCURSOR
    jnz     false
    invoke  SetCursor,[hCursor]
    jmp     true

false:

    xor     eax,eax
    ret

true:

    mov     eax,1
    ret
    
ENDP